(function() {
  var InstagramMedia;
  InstagramMedia = (function() {
    function InstagramMedia(parent) {
      this.parent = parent;
    }
    /*
      Basic Media
      */
    InstagramMedia.prototype.popular = function(params) {
      var credentials;
      credentials = this.parent._credentials({});
      params['path'] = "/" + this.parent._api_version + "/media/popular?" + (this.parent._to_querystring(credentials));
      return this.parent._request(params);
    };
    InstagramMedia.prototype.info = function(params) {
      var credentials;
      credentials = this.parent._credentials({});
      params['path'] = "/" + this.parent._api_version + "/media/" + params['media_id'] + "?" + (this.parent._to_querystring(credentials));
      return this.parent._request(params);
    };
    InstagramMedia.prototype.search = function(params) {
      params = this.parent._credentials(params);
      params['path'] = "/" + this.parent._api_version + "/media/search?" + (this.parent._to_querystring(params));
      return this.parent._request(params);
    };
    /*
      Likes
      */
    InstagramMedia.prototype.likes = function(params) {
      var credentials;
      credentials = this.parent._credentials({});
      params['path'] = "/" + this.parent._api_version + "/media/" + params['media_id'] + "/likes?" + (this.parent._to_querystring(credentials));
      return this.parent._request(params);
    };
    InstagramMedia.prototype.like = function(params) {
      params['post_data'] = this.parent._credentials({}, 'access_token');
      params['method'] = 'POST';
      params['path'] = "/" + this.parent._api_version + "/media/" + params['media_id'] + "/likes";
      return this.parent._request(params);
    };
    InstagramMedia.prototype.unlike = function(params) {
      params = this.parent._credentials(params, 'access_token');
      params['method'] = 'DELETE';
      params['path'] = "/" + this.parent._api_version + "/media/" + params['media_id'] + "/likes?" + (this.parent._to_querystring(params));
      return this.parent._request(params);
    };
    /*
      Comments
      */
    InstagramMedia.prototype.comments = function(params) {
      var credentials;
      credentials = this.parent._credentials({});
      params['path'] = "/" + this.parent._api_version + "/media/" + params['media_id'] + "/comments?" + (this.parent._to_querystring(credentials));
      return this.parent._request(params);
    };
    InstagramMedia.prototype.comment = function(params) {
      params['post_data'] = this.parent._credentials({
        text: params['text']
      }, 'access_token');
      params['method'] = 'POST';
      params['path'] = "/" + this.parent._api_version + "/media/" + params['media_id'] + "/comments";
      return this.parent._request(params);
    };
    InstagramMedia.prototype.uncomment = function(params) {
      var credentials;
      credentials = this.parent._credentials({}, 'access_token');
      params['method'] = 'DELETE';
      params['path'] = "/" + this.parent._api_version + "/media/" + params['media_id'] + "/comments/" + params['comment_id'] + "?" + (this.parent._to_querystring(credentials));
      return this.parent._request(params);
    };
    /*
      Subscriptions
      */
    InstagramMedia.prototype.subscribe = function(params) {
      params['object'] = 'geography';
      return this.parent.subscriptions._subscribe(params);
    };
    InstagramMedia.prototype.unsubscribe = function(params) {
      return this.parent.subscriptions._unsubscribe(params);
    };
    InstagramMedia.prototype.unsubscribe_all = function(params) {
      params['object'] = 'geography';
      return this.parent.subscriptions._unsubscribe(params);
    };
    return InstagramMedia;
  })();
  module.exports = InstagramMedia;
}).call(this);
